# KrakenPHP Framework

[![Total Downloads](https://poser.pugx.org/kraken-php/framework/downloads)](https://packagist.org/packages/kraken-php/framework) [![Latest Stable Version](https://poser.pugx.org/kraken-php/framework/v/stable)](https://packagist.org/packages/kraken-php/framework) [![Latest Unstable Version](https://poser.pugx.org/kraken-php/framework/v/unstable)](https://packagist.org/packages/kraken-php/framework) [![License](https://poser.pugx.org/kraken-php/framework/license)](https://packagist.org/packages/kraken-php/framework)

## Description

KrakenPHP is the first and only multi-processed, multi-threaded, fault-tolerant framework for PHP. It has been written
to provide easy and reliable API for creating distributed applications using PHP. KrakenPHP aims to solve typical 
problems of writing such applications and to provide developers with powerful yet elegant tools for dealing with them. 

The main focus of KrakenPHP is put on: 
* __Concurrency and distribution__ : create systems that are asynchronous and distributed by design. Run them on multiple threads, processors or hosts and manage from single place.
* __Error tolerance__ : write systems that self-heal using remote and local supervision hierarchies.
* __Elasticity__ : keep business logic of your applications inside universal containers and connections between them separately. Modify existing architecture and number of running containers in realtime without need to change in code.
* __High performance__ : handle up to thousands of simultaneous connections per second on single container. Use multiple containers on several processors and/or hosts to push it even further.
* __Extensibility__ : use available options to easily extend and adapt framework features for your needs.

Start writing applications that were previously marked as impossible or hard to implement in PHP right know. 
Servers, service-oriented architecture, agent-based models, games, complex daemons, socket programs, schedulers 
and much, much more - nothing is impossible with KrakenPHP!

## Features

Full list of features can be found on [official webpage][1].

## Official Documentation

Documentation for the framework can be found in the [official documentation][2].

## Installation

Installation instructions can be found in [installation guide][3].

## Frequently Asked Questions

If there are any questions that you have about framework, you can check whether the answers 
for them have been already posted in [faq topic][4].

## Contributing

Thank you for considering contributing to KrakenPHP framework! The contribution guide can be found in the [contribution tips][5].

### License

KrakenPHP framework is open-sourced software licensed under the [MIT license][6].

[1]: http://kraken-php.com
[2]: http://kraken-php.com/docs
[3]: http://kraken-php.com/getting_started
[4]: http://kraken-php.com/faq
[5]: http://kraken-php.com/docs/contributions
[6]: http://opensource.org/licenses/MIT
